"use strict";
var bunyan = require("bunyan");
var platform_stream_1 = require("./platform-stream");
var CentralLogger = (function () {
    function CentralLogger(cfg) {
        cfg = cfg || {};
        this.platformStream = new platform_stream_1.PlatformStream(cfg);
        this.root = bunyan.createLogger({
            name: 'system',
            streams: [{
                    level: cfg.level || 'info',
                    stream: this.platformStream
                }]
        });
    }
    CentralLogger.prototype.trace = function () {
        return this.root.trace.apply(this.root, arguments);
    };
    CentralLogger.prototype.debug = function () {
        return this.root.debug.apply(this.root, arguments);
    };
    CentralLogger.prototype.info = function () {
        return this.root.info.apply(this.root, arguments);
    };
    CentralLogger.prototype.warn = function () {
        return this.root.warn.apply(this.root, arguments);
    };
    CentralLogger.prototype.error = function () {
        return this.root.error.apply(this.root, arguments);
    };
    CentralLogger.prototype.fatal = function () {
        return this.root.fatal.apply(this.root, arguments);
    };
    CentralLogger.prototype.child = function (opts) {
        return this.root.child(opts);
    };
    return CentralLogger;
}());
exports.CentralLogger = CentralLogger;

//# sourceMappingURL=central-logger.js.map
