"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var stream_1 = require("stream");
var platform_locator_1 = require("../platform/platform-locator");
var PlatformStream = (function (_super) {
    __extends(PlatformStream, _super);
    function PlatformStream(cfg) {
        var _this = this;
        _super.call(this);
        // Establish underlying connection to the platform
        this.platform = platform_locator_1.PlatformLocator.connect(cfg).then(function (platform) {
            // Retrieve a logging service matching our needs. For performance,
            // we pre-resolve the service instead of relying on the platform capacity
            // to resolve services based on requests
            _this.logService = platform.resolveService({
                group: 'system:monitor',
                action: "log"
            });
            return platform;
        });
    }
    PlatformStream.prototype._write = function (chunk, encoding, next) {
        // Record log using our logging service
        this.logService.then(function (service) {
            return service.exec({
                action: 'log',
                payload: {
                    data: chunk,
                    encoding: encoding
                }
            });
        })
            .then(function (result) {
            return next(null, result);
        }).catch(next);
    };
    return PlatformStream;
}(stream_1.Writable));
exports.PlatformStream = PlatformStream;

//# sourceMappingURL=platform-stream.js.map
